#############################################################################
#
#  			Copyright 2003 MPIMG Berlin, Germany.
#			      All Rights Reserved
#
#
#  System        : 
#  Module        : 
#  Object Name   : $RCSfile: dgMKViewer.tcl,v $
#  Revision      : $Revision: 1.1 $
#  Date          : $Date: 2004/02/20 13:45:24 $
#  Author        : $Author: dgroth $
#  Created By    : Dr. Detlef Groth
#  Created       : Mon Mar 10 16:41:10 2003
#  Last Modified : <041108.1120>
#
#  Description	
#
#  Notes
#
#  History
#	
#  $Log: dgMKViewer.tcl,v $
#  Revision 1.1  2004/02/20 13:45:24  dgroth
#  inital cvs import after adjusting to usage inside dgTools.kit
#
#
##############################################################################
#
#  Copyright (c) 2003 MPIMG Berlin, Germany.
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################

package provide app-dgMKViewer 1.0
package provide app-DGMKVIEWER 1.0
set var(version) 0.4b5
package require Tk
package require dgwidgets
splash .splash -product "dgMKViewer $var(version)" \
          -copyright "Copyright 2003 by Dr. Detlef Groth" \
          -msg "Loading ..." \
          -image "[file rootname [info script]].gif"
.splash update "Loading packages ..."
# append kitdir into auto_path
set libdir [file join "[file rootname [info script]].vfs" lib]
if {[file exists $libdir]} {
    lappend auto_path $libdir
}
# check .whishrc
if {[file exists [file join $env(HOME) .wishrc]]} {
    source "[file join $env(HOME) .wishrc]"
}
set imgdir [file join "[file rootname [info script]].vfs" images]
if {![file exists $imgdir]} {
   set imgdir [file join [file dirname [info script]] .. .. images]
}
lappend auto_path [file join [file dirname [info nameofexe]] lib]
package require BWidget
package require iniparse
package require Wikit
package require starkit
package require wcb
package require tablelist 
package require oomk 
package require Mk4tcl
package require dgwidgets
#package require Console ;
namespace import tablelist::tablelist
catch {
    package require dde
    dde servername MKViewer
}
catch {package require Img }
set var(sqlite) false
set var(sqlite.kit) [file join [file dirname [info nameofexe]] lib sqlite.kit]

catch {source $var(sqlite.kit)}
catch {package require sqlite; set var(sqlite) true }
set dir [file dirname [info script]] 
source [file join $dir iniload.tcl]
source [file join $dir dgutils.tcl]
#source [file join $dir dgroth.res]
global var
global gui
global data
global mnu
set var(lastdir) $dir
set var(resfile) [file rootname $argv0].res


set var(debug) 1
set var(busy) false
set var(mkopen) 0
set var(fileload) 0
set var(types) { 
    {{Image Files}       {.jpg .gif} }
    {{Text Files}       {.txt } }
    {{All Files}        *        }
}
#set var(debug) tk
.splash update "Creating images ..."
set img(table) [image create photo -file "[file join $imgdir tables.gif]"]
set img(view) [image create photo -file  "[file join $imgdir view.gif]"]
set img(field) [image create photo -file  "[file join $imgdir field.gif]"]
set sep(space) " "
set sep(tab) "\t"
set sep(comma) ","
set sep(semicolon) ";"
set var(gui,data,stretch) true
#bind all <Key-F2> { interp create ip2 ; ip2 eval {puts hi}}
if {[string compare unix $tcl_platform(platform)]} {
    # get rid of the console on windows/mac
    #catch {rename console winconsole}
}
proc main {} {
    global gui var img data mnu argv
    .splash update "Creating GUI ..."
    set var(appname) [file rootname [file tail [info script]]]
    catch {
        lappend auto_path [file join [file dirname [info script]] .. lib]
        package require winsend
        winsend appname $var(appname)-[clock format [clock seconds] -format "%a-%H-%M"]
        bind all <Control-F7> {
            if {[llength [info commands winsend]] > 0} {
                winsend send [winsend appname] [clipboard get]
                bell
            }
        }
    }
    set dir [file dirname [info script]]
    catch {wm iconbitmap . -default "[file join $dir .. .. $var(appname).ico]"}
    ini_load RECENTS 10 LASTFILE 1
   
    License:Check
  
    wm title . "$var(appname) $var(version)"
    set geo 400x400+20+20 
    if {[llength $argv] > 1} {
        array set arg $argv
        if {[info exists arg(-geometry)]} {
            set geo $arg(-geometry)
        }
    }
   # wm geometry . $geo ;# a fix for not showing the statusline on small monitors
    menu .menubar
    . config -menu .menubar
    set mnu(file) [menu .menubar.file -tearoff 0]
    set mnu(options) [menu .menubar.options -tearoff 0]
    .menubar add cascade -label File -underline 0 -menu $mnu(file) 
    .menubar add cascade -label Options -underline 0 -menu $mnu(options) 
    $mnu(options) add checkbutton -label "stretch table" -variable var(gui,data,stretch)
    set mnu(help) [menu .menubar.help -tearoff 0]
    .menubar add cascade -label Help -underline 0 -menu $mnu(help) 
    $mnu(help) add command -label "About ... " -underline 0 -command \
             { tk_messageBox -title "About!" -icon info \
              -message "$var(appname) by Dr. Detlef Groth\n\n     2003\n\n   detlef@dgroth.de" -type ok}
    
    $mnu(help) add command -label "Help" -underline 0 -command {help 0}
    $mnu(help) add command -label "Changes" -underline 0 -command {help 16}
    $mnu(help) add separator
    $mnu(help) add command -label "Homepage" -underline 1 -command "browser:urlOpen http://www.dgroth.de/tcltk_dgmkviewer.html"
    $mnu(help) add command -label "Supporting" -underline 0 -command "browser:urlOpen http://www.dgroth.de/support.html"
    $mnu(file) add command -label "New File ..." -underline 0 -command File:New
    $mnu(file) add command -label "Open File ..." -underline 0 -command File:Open
    #$mnu(file) add command -label "Disconnect ..." -underline 0 -command { catch {mk::file close mkdb}}
    $mnu(file) add separator
    set mnu(file-recent) [menu .menubar.file.recent -tearoff 0]
    .menubar.file add cascade -label "Recent Files ..." -underline 0 -menu $mnu(file-recent) 
    
    ini_mnu_install $mnu(file-recent) RECENTS File:Load 9
  
    ini_mnu_update  $mnu(file-recent) RECENTS File:Load 9
    $mnu(file) add separator
    $mnu(file) add command -label "Import Table ..." -underline 0 -command Table:Import -state disabled
    $mnu(file) add command -label "Export Table ..." -underline 0 -command Table:Export -state disabled
   
    
    $mnu(file) add separator
    $mnu(file) add command -label "Import Table into current View ..." -underline 0 -command {Table:Import yes} -state disabled
   
    if {$var(sqlite)} {
        $mnu(file) add separator
        $mnu(file) add command -label "Import SQLite Database ..." -underline 0 -command SQLite:Import -state disabled
        $mnu(file) add command -label "Export SQLite Database ..." -underline 0 -command SQLite:Export -state disabled
    }
        
    $mnu(file) add separator
    $mnu(file) add command -label Exit -underline 1 -command  { Exit}
    wm protocol . WM_DELETE_WINDOW Exit
    if { [ini_option_get LASTFILE ] ne "" } {
        set var(lastfile) [ini_option_get LASTFILE]
        set var(lastdir) [file dirname $var(lastfile)]
    } 
    if { [ini_option_get LASTRECORD ] ne "" } {
        set var(record-filedir) [ini_option_get LASTRECORD]
        
    } else {
        ini_option_set LASTRECORD .
    }
    set widgets [Paned .w vertical frame frame] ;#
    set f [lindex $widgets 1]
    set tableframe [lindex $widgets 2]
    pack [NoteBook $tableframe.nb -side top] -fill both -expand yes
    set gui(nb-data) $tableframe.nb
    $gui(nb-data) bindtabs <ButtonPress-3> NoteBook:Popup
    set var(nb-total) 1
    NoteBook:AddPage
    set widgets [Paned $f.pw horizontal Tree tablelist frame]
    set gui(tree) [lindex $widgets 1]
    $gui(tree) bindText <1> Tree:TextSelect
    
    set gui(views) [lindex $widgets 2]
    $gui(views) configure -labelcommand  tablelist::sortByColumn
    set mframe [lindex $widgets 3]
    #pack [frame $mframe.subf] -side left
    #pack [frame $mframe.subf.subf] -side left -padx 5 -pady 5 -anchor w
    #pack [console $mframe.c -height 10] -fill both -expand true -side right
    #set gui(text) [Scrolled $mframe text -width 100]
    set var(count) 100
    pack [frame $mframe.f] -side top  -expand yes -fill x 
    pack [labelframe $mframe.f.size -text "Data View Size"] -side left -expand yes -fill x -ipadx 5 -ipady 5 -padx 5 -pady 5
    mLabSpinBox $mframe.f.size.start -labeltext "start: " -labelwidth 10 \
              -width 8 -from 0 -to 100000 -increment 100 -textvariable var(start)
    mLabSpinBox $mframe.f.size.count -labeltext "count: " -labelwidth 10 \
              -width 8 -from 0 -to 1000 -increment 100 -textvariable var(count)
    pack [labelframe $mframe.f.save -text "Save View / Join"] -side left -expand yes -fill x -ipadx 5 -ipady 5 -padx 5 -pady 5
    LabelEntry $mframe.f.save.lentry -textvariable var(saveviewname) -helptext "Enter a viewname to save the operation into current database"
    Pack:Childs $mframe.f.size -side left -padx 5 -pady 3 
    Pack:Childs $mframe.f.save -side left -padx 5 -pady 3
    pack [NoteBook $mframe.nb -side top] -fill both -expand yes
    
    set gui(nb) $mframe.nb
    $gui(nb) insert end select -text select
    $gui(nb) insert end join -text join -createcmd GUI:Join
    $gui(nb) insert end oomk -text oomk -createcmd GUI:Oomk
    $gui(nb) insert end view -text view
    $gui(nb) insert end fileview -text fileview
 
    set fselect [$gui(nb) getframe select]
    set gui(fjoin) [$gui(nb) getframe join] 
    set gui(foomk) [$gui(nb) getframe oomk] 
    set fview [$gui(nb) getframe view]
    set ffileview [$gui(nb) getframe fileview]
    
    set gui(fileview) [Scrolled $ffileview text]
  
    #pack $sf -expand true -fill both
    #pack $sw -expand true -fill both
   
#    pack [labelframe $mframe.lbl  -text " mk::select " ] -expand no -fill both    
    #set fselect $mframe.lbl
  
    #pack $gui(text) -side top
    
    label $fselect.lblview -text "View: " -width 10
    ComboBox $fselect.cb0 -editable false -textvariable var(lastview) \
              -postcommand { $gui(lastview) configure -values [Mk:GetViews]
    }
    set gui(lastview) $fselect.cb0
    grid $fselect.lblview $fselect.cb0 -sticky news
    #    label $fselect.lblstart -text "start: " -width 10
    #    spinbox $fselect.start -width 8 -from 0 -to 100000 -increment 100 -textvariable var(start)
    #    grid $fselect.lblstart $fselect.start -sticky news
    #    
    #    #pack [frame $fselect.] -side top -padx 5 -pady 5 -anchor w
    #    label $fselect.lblstart2 -text "count: " -width 10
    #    pack [spinbox $fselect.start2 -width 8 -from 100 -to 1000 -increment 100 -textvariable var(count)]  -side left -fill x -expand no
    #    grid $fselect.lblstart2 $fselect.start2  -sticky news
    #pack [frame $fselect.] -side top -padx 5 -pady 5 -anchor w
    label $fselect.lbls -text "search: " -width 10
 
    set var(searchmode) glob
    set var(search) *
    
    ComboBox $fselect.cb -editable false -values {min max exact glob globnc regexp keyword} -textvariable var(searchmode)
    grid $fselect.lbls $fselect.cb  -sticky news
    label $fselect.lbl2 -text "column: " -width 10
    ComboBox $fselect.cb2 -editable false -values {null null} -textvariable var(searchcolumn)
    lappend gui(cb-columns) $fselect.cb2
    grid $fselect.lbl2 $fselect.cb2  -sticky news
    label $fselect.lbl3 -text "value: " -width 10
    ComboBox $fselect.cb3 -values {GO*} -textvariable var(search)
  
    grid $fselect.lbl3 $fselect.cb3  -sticky news
    grid [ComboBox $fselect.lblsort -values {nosort sort rsort} -width 8 -editable false -text nosort -textvariable var(sort-1)] [ComboBox $fselect.sort -values {" "} -textvariable var(sortcolumn-1)]  -sticky news
    grid [ComboBox $fselect.lblsort2 -values {nosort sort rsort} -width 8 -editable false -text nosort -textvariable var(sort-2)] [ComboBox $fselect.sort2 -values {" "} -textvariable var(sortcolumn-2)] -sticky news
    lappend gui(cb-columns) $fselect.sort
    lappend gui(cb-columns) $fselect.sort2
#    grid [label $fselect.stm  -textvariable var(stm) -anchor c -relief ridge] -columnspan 2 -pady 10 -ipadx 5 -ipady 5
    grid [button $fselect.btn -text Execute -command Oomk:Command] -columnspan 2 -pady 10 -ipadx 5 -ipady 5 ;#-padx 10 -pady 10
    #pack [labelframe $mframe.view -text "mk::view "] -fill both -expand yes

    #set fview $mframe.view
    #pack [ComboBox $fview.cb1 -editable false -values {null delete} -textvariable var(mkview)] -side left
    pack [labelframe $fview.lbf -text "Delete View "] -side top -expand yes -fill both
    mComboBox $fview.lbf.f0 -labeltext  View: -editable false -values {null null} -textvariable var(mkviewdelete) -postcommand { $gui(cb-views) configure -values [Mk:GetViews]}
    set gui(cb-views) $fview.lbf.f0
    pack $gui(cb-views) -side left -fill x -padx 5 -pady 5
    button $fview.lbf.exec -text " Delete View " -command { 
        set answer [tk_messageBox -title "Question!" -message "Really delete $var(mkviewdelete)?" -type yesno -icon question]
        if { $answer } {
            Mk:Open $var(lastfile)
            if { [ catch { mk::view delete mkdb.$var(mkviewdelete) } ] } {
                tk_messageBox -title "Error!" -icon error -message "$var(mkviewdelete) seems to be non existing!" -type ok
            }
            set var(mkviewdelete) ""
            #$gui(cb-views) subwidget entry delete 0 end
            Mk:Close
            File:Load $var(lastfile)
        }
        
    }
    pack $fview.lbf.exec -side left -fill x -padx 5 -pady 5
  
    pack [labelframe $fview.lbf1 -text "Rename / Copy View "] -side top -expand yes -fill both
    pack [frame $fview.lbf1.f] -side top -expand yes -fill both
    pack [mComboBox $fview.lbf1.f.from -labeltext "Oldname:" -labelside top -textvariable var(view,rename,from) \
          -postcommand { $gui(oldname) configure -values [Mk:GetViews]} ] -side left -fill x -padx 5 -pady 5
    set gui(oldname) $fview.lbf1.f.from
    pack [mLabEntry $fview.lbf1.f.to -labeltext "Newname:" -labelside top -textvariable var(view,rename,to)] -side left -fill x -padx 5 -pady 5
    button $fview.lbf1.f.exec -text " Rename " -command {
        Oomk:ViewRename $var(view,rename,from) $var(view,rename,to) ; 
        File:Load $var(lastfile) ; 
        #set var(statustext) "$var(view,rename,to) created"
    }
    button $fview.lbf1.f.exec2 -text " Copy " -command {
        Oomk:ViewCopy $var(view,rename,from) $var(view,rename,to) ; 
        #File:Load $var(lastfile) ; 
        #set var(statustext) "$var(view,rename,to) created"
    }
    pack $fview.lbf1.f.exec  $fview.lbf1.f.exec2 -padx 5 -pady 5 -side left -fill x -padx 5 -pady 5
    pack [labelframe $fview.lbf2 -text "Create View "] -side top -expand yes -fill both
    set var(create-layout-cols) "first last shoezize:I"
    set var(create-layout-view) "Viewname"
    pack [mComboBox $fview.lbf2.f2 -labeltext "View:" -textvariable var(create-layout-view)] -fill x -padx 5 -pady 10
    set gui(view-view-add) $fview.lbf2.f2
    
    pack [mComboBox $fview.lbf2.f3 -labeltext " Cols:" -textvariable var(create-layout-cols)] -fill x -padx 5 -pady 10
    set gui(view-cols-add) $fview.lbf2.f3
    
    button $fview.lbf2.layout_exec_btn -text " Create View " -command {
          if [string match "*\{*" $var(create-layout-cols)] {
              tk_messageBox -title "Info!" -icon info -message "Sorry no subview creation is allowed here!" -type ok
          } else {
              Mk:Open $var(lastfile)
              mk::view layout mkdb.$var(create-layout-view) $var(create-layout-cols)
              mk::row insert mkdb.$var(create-layout-view)!0 1
              Mk:Close
              File:Load $var(lastfile)
              $gui(view-view-add) addHistory $var(create-layout-view)
              $gui(view-cols-add) addHistory $var(create-layout-cols)
          }
      }
      pack $fview.lbf2.layout_exec_btn -padx 5 -pady 10

      $gui(views) configure -columns {0 "view" 0 "size" 0 "columns" } -stretch all
      
      bind [$gui(data) bodypath] <Button-3> { 
        set filename [Table:GetCellText $gui(data) [expr {%x + [winfo x %W]}] [expr {%y + [winfo y %W]}]]
        if [file exists $filename] {
            catch {destroy $gui(fileview).btn }
            if {[lsearch {.jpg .gif .jpeg .bmp .ppm} "[string tolower [file extension $filename]]"] >= 0} {
                set imgt [image create photo -file $filename]
                button $gui(fileview).btn -image $imgt -command {
                    catch {destroy .photo}
                    toplevel .photo
                    pack [button .photo.btn -image [$gui(fileview).btn cget -image]]
                    pack [button .photo.close -text " Close " -command {destroy .photo}]
                }
                $gui(fileview) delete 1.0 end
                $gui(fileview) window create end -window $gui(fileview).btn
                $gui(fileview) insert end "\n$filename\n"
            } else {
            
                Text:LoadFile $gui(fileview) $filename
            }    
        } else {
            if {$filename ne ""} {
                $gui(fileview) delete 1.0 end
                $gui(fileview) insert end "\n$filename does not exists!\n"
            }
        }
        
    }
    bind [$gui(views) bodypath] <Button-3> {Oomk:Command}
    bind [$gui(views) bodypath] <Button-1> { 
        catch {
            set index [Table:GetRow [expr {%x + [winfo x %W]}] [expr {%y + [winfo y %W]}]]
            set view [$gui(views) cellcget [lindex [split $index ,] 0],0 -text]
            #tk_messageBox -title "Info!" -icon info -message "View: $view" -type ok
            set var(lastview) $view
            Mk:Open $var(lastfile)
            set var(searchmode) glob
            set var(search) *
            $mnu(file) entryconfigure 6 -state normal
            set var(searchcolumn) [lindex [mk::view layout mkdb.$var(lastview)] 0]
            catch {  
                foreach cb $gui(cb-columns) {
                    $cb configure -values [mk::view layout mkdb.$var(lastview)] 
                }
            }
            Mk:Close
        }
        
    }
    pack [frame $tableframe.status -height 15] -side top -fill x -expand no
    set var(statustext) "dgMKViewer loaded"
    pack [Label $tableframe.status.le -text labeltext -textvariable var(statustext)] -side left
    set var(progress) 0
    pack [mProgressBar $tableframe.status.pb0 -textvariable var(progress) -variable var(progress)] -side right -ipady 3 -ipadx 3
    #    pack [ProgressBar .status.pb -maximum 100 -variable var(progress)] -side right
    #    set gui(progressbar) .status.pb
    #    pack [label .status.lb2  -text " % "] -side right
    #    pack [label .status.lb  -textvariable var(progress)] -side right
   
    set var(progress) 0
    #$gui(nb) raise [$gui(nb) page 0]
    # a fix to avoid bug with text area shown in other than own tab ...
    $gui(nb) raise [$gui(nb) page 1]
    $gui(nb) raise [$gui(nb) page 2]
    $gui(nb) raise [$gui(nb) page 3]
    $gui(nb) raise [$gui(nb) page 4]
    $gui(nb) raise [$gui(nb) page 0]
    $gui(nb-data) raise [$gui(nb-data) page 0]
    trace variable var rwu Trace:Var
    
    if {[info exists var(lastfile)] && [file exists $var(lastfile)]} {
        .splash update "Loading $var(lastfile) ..."
        File:Load $var(lastfile)
        $mnu(file) entryconfigure 5 -state normal
    }
    #    if {[ini_option_get GEOMETRY] ne ""} {
    #        catch {wm geometry . [ini_option_get GEOMETRY]}
    #    }
    .splash remove
    
}
proc Oomk:HasView {view} {
    set ret no
    foreach v [db layout] {
        if {[lindex $v 0] eq "$view"} {
            set ret yes
            break
        } 
    }
    return $ret
}
proc Mk:HasView {viewname} {
    global var
    set ret no
    set close false
    if {$var(mkopen) == 0} {
        Mk:Open $var(lastfile)
        set close true
    }
    foreach v [mk::view layout mkdb] { 
        if {[lindex $v 0] eq "$viewname"} {
            set ret yes
            break
        } 
    }
    if {$close} {
        Mk:Close
    }
    return $ret
}
proc Mk:Lock {file lock} {
    set out [open $file.lock w 0600]
    puts $out "locked by [info script]"
    close $out
}
proc Mk:Open {file} {
    global var
    if {!$var(busy)} {
        set var(busy) true
        catch {mk::file close mkdb}
        if {$var(mkopen) == 0} {
            mk::file open mkdb $file
            set var(mkopen) 1
            return true
        }
        
    }
    return false
}
proc Mk:Close {} {
    global var
    catch {mk::file close mkdb}
    set var(mkopen) 0
    set var(busy) false
}
proc Oomk:Command {} {
    global var gui
    if {$var(fileload) == 0} {
        tk_messageBox -title "Error!" -icon error -message "No file was loaded!" -type ok
        return
    }
    set sorting [list]
    
    if {$var(sort-1) ne "nosort"}  {
        lappend sorting "-$var(sort-1)"
        lappend sorting "$var(sortcolumn-1)"
        if {$var(sort-2) ne "nosort"}  {
            lappend sorting "-$var(sort-2)"
            lappend sorting "$var(sortcolumn-2)"
        }
    }
    # -count $var(count) removed    
    #set var(stm-$var(nb-raised)) $var(stm)
    set var(view-$var(nb-raised)) $var(lastview)
    $gui(nb-data) itemconfigure [$gui(nb-data) raise] -text "$var(lastview) -first $var(start) -$var(searchmode) $var(searchcolumn) $var(search) $sorting"
    set db [mkstorage %AUTO% $var(lastfile)]
    
    [$db view $var(lastview)] as mview
    [$mview select -first $var(start) -$var(searchmode) $var(searchcolumn) $var(search) [lindex $sorting 0] [lindex $sorting 1] [lindex $sorting 2] [lindex $sorting 3]] as view
   
    
    # configure columns
    set columns [list n rec]
    foreach col [$view properties] {
        if {[string match "*:V" $col]} {
            #            [db view $var(lastview).$col] as subview
            #            foreach subcol [$subview properties] {
            #                lappend columns ${col}.$subcol
            #            }
        } else {
            lappend columns  $col
        } 
    }
    Tablelist:Colconf $gui(data) 20 $columns     
  
    # todo replacement Mk:Command
    Oomk:Execute table select $view $db
   
   
}
proc Mk:Command {} {
    global var gui
    if {$var(fileload) == 0} {
        tk_messageBox -title "Error!" -icon error -message "No file was loaded!" -type ok
        return
    }
    #set command [$gui(text) get 1.0 end]
    #regsub -all {\s+} $command " " command
    set view $var(lastview)
    if {![Mk:Open $var(lastfile)]} {
        Mk:Close
        return
    }
    
  
    #tk_messageBox -title "Info!" -icon info -message "lastview: '$view'" -type ok
    set columns [list n rec]
    foreach col [mk::view layout mkdb.$view] {
        if {[llength $col] == 1} {
            lappend columns  $col
        } else {
            #lappend columns [lindex $col 0]
            set n 0
            #Debug $col
            set subcols [lindex $col 1]
            foreach subcol $subcols {
                lappend columns "[lindex $col 0]:$subcol"
                incr n
            }
        }
    }
    
    Tablelist:Colconf $gui(data) 20 $columns
    #set columns [mk::file views mkdb.$view]
    #$gui(data) configure -columns $cols
    $gui(data) delete 0 end
    #mk::select mkdb.$view -first 0 -count 10
    set sorting " "
    if {$var(sort-1) ne "nosort"}  {
        set sorting "-$var(sort-1) $var(sortcolumn-1) "
        if {$var(sort-2) ne "nosort"}  {
            set sorting "$sorting -$var(sort-2) $var(sortcolumn-2) "
        }
    }
    # -count $var(count) removed    
    set var(stm) "mk::select mkdb.$view -first $var(start) -$var(searchmode) $var(searchcolumn) $var(search) $sorting"
    set var(stm-$var(nb-raised)) $var(stm)
    set var(view-$var(nb-raised)) $view
    $gui(nb-data) itemconfigure [$gui(nb-data) raise] -text $view
    set command "mk::select mkdb.$view -first $var(start)  -$var(searchmode) $var(searchcolumn) $var(search) $sorting"
    #tk_messageBox -title "Info!" -icon info -message "message mk::select mkdb.$view -first $var(start)  -$var(searchmode) $var(searchcolumn) $var(search) $sorting" -type ok
    set n 0
    foreach r [eval $command]  {
        if {$n == $var(count)} {
            break
        }
        $gui(data) insert end test
        set lastbeige $n
        incr n
        $gui(data) cellconfigure end,0 -text $n
        $gui(data) cellconfigure end,1 -text $r
        set x 0
        set y 2
        set cols [mk::view layout mkdb.$view]
        foreach col  $cols {
            if {[llength $col] == 1} {
                $gui(data) cellconfigure end,$y -text [mk::get mkdb.$view!$r [lindex $cols $x]] 
                #
               
                incr y
            } else {
                set subview [lindex $col 0]
                set subcols [lindex $col 1]
               
               
                foreach subRec [mk::select mkdb.$view!$r.$subview] {
                    if {$subRec == 0} {
                        $gui(data) rowconfigure $lastbeige -background beige
                    }
                    incr n
                    #$gui(data) cellconfigure end,0 -text $n
                    #$gui(data) cellconfigure end,1 -text $r
                    set y2 $y
                    $gui(data) insert end "$n"
                    $gui(data) cellconfigure end,1 -text "$r.$subview!$subRec"
                    for {set z 2} {$z <= $y} {incr z} {
                        $gui(data) cellconfigure end,$z -text [$gui(data) cellcget $lastbeige,$z -text]
                    }
                    foreach {header col} [mk::get mkdb.$view!$r.$subview!$subRec] {
                        if {[Mk:GetType $header] eq "B"} { 
                            $gui(data) cellconfigure end,$y2 -text "binary"
                        } else {
                            #regsub {:[A-Z]} "$subcol" "" subcol
                            $gui(data) cellconfigure end,$y2 -text "$col"
                        }
                        incr y2
                    }
                }
            }
            incr x
            
        }
        if {[expr $n % 50]  == 0} {
            set var(progress) [expr $n * 100 / $var(count)]
            set var(statustext) "$n items processed"
            #update 
            update idletasks
        }
        
    }
    set cols {}
    Mk:Close
    set var(progress) 100
    set var(statustext) "$n items processed"

    
}
proc Table:Export {} {
    global var
    set dialog [Dialog .dialog \
                -title "Export Options" \
                -anchor e]
    set uf [$dialog getframe]
 
       
    pack [checkbutton $uf.header -text "Output column headers" -variable var(header)]
    pack [frame $uf.lf ]
    pack [label $uf.lf.lbl -text "Field Separator"] -side left
    pack [ComboBox $uf.lf.cb -text "Comma" -values "comma semikiolon tab space" -textvariable var(export,extension)] -side left
#    pack [radiobutton $uf.lf.comma -text "Comma    " -variable var(sep)]
#    pack [radiobutton $uf.lf.semi -text "Semikolon" -variable var(sep)]
#    pack [radiobutton $uf.lf.tab -text "Tabs       " -variable var(sep)]
#    pack [radiobutton $uf.lf.space -text "Space     " -variable var(sep)]
    #pack [tk_option
    grid columnconfigure $uf 1 -weight 1
    set var(export,extension) "comma"
    $dialog add -text "Submit" -command [list $dialog enddialog "submit"]
    $dialog add -text "Cancel" -command [list $dialog enddialog "Cancel"]
    set result [$dialog draw]
    if {[string equal $result "submit"]} {
        set types {
            {{CSV Files}       {.csv}        }
            {{Tab Files}       {.tab}        }
            {{All Files}        *             }
        }
        switch -exact -- $var(export,extension) {
            comma - 
            semikolon - 
            comma {
               set var(export,ext) csv 
            }
            default {
                set var(export,ext) tab
            }
        }
        if {[ini_option_get LASTEXPORTDIR] eq ""} {
            set inidir "."
        } else {
            set inidir [ini_option_get LASTEXPORTDIR]
        }
        set savefile [tk_getSaveFile -filetypes $types -title "Export $var(lastview)" \
                      -initialdir $inidir \
                      -initialfile "$var(lastview).$var(export,ext)"]
        if {$savefile != ""} {
            ini_option_set LASTEXPORTDIR [file dirname $savefile]
            Mk:Open $var(lastfile)
            set out [open $savefile w 0600]
            #        set headers [mk::view layout  mkdb.$var(lastview)]
            set headers [mk::view layout  mkdb.$var(lastview)]
            set sep "\t"
            switch -exact -- $var(export,extension) {
                comma {
                    set sep ","
                }
                semikolon {
                    set sep ";"
                }
                space {
                   set sep " " 
                }
            }
            regsub -all " " $headers "$sep" headers
            set cols [split $headers "$sep"]
            #set vw [mk::view layout  mkdb.$var(lastview)]
            puts $out $headers
         
            mk::loop c mkdb.$var(lastview) {
                set o ""
                foreach el $cols {
                    if {$o ne ""} {
                        set o "$o$sep[mk::get $c $el]"
                    } else {
                        set o "[mk::get $c $el]"
                    }
                }
                puts $out "$o"
            }
            
            #foreach r [mk::select $vw] {puts $out [mk::get $vw!$r]}
            
            close $out
            Mk:Close
            set var(statustext) "$savefile was saved"
        
            
        }
    }
        
    destroy .dialog
    
}
proc Table:Import:GetHeaders {} {
    global import
    set cols {}
    for {set i 1} {$i <= $import(max) } {incr i 1} {
        if {$import(include-$i) == 1} {
            if {[regexp {[A-Z]} $import(type-$i)]} {
                lappend cols $import(column-$i):$import(type-$i)
            } else {
                lappend cols $import(column-$i)
            }
        }
    }
    return $cols
}
proc Table:Import {{append no}} {
    global var gui sep import
    set types {
        {{Tabulierte Files}  {.tab}      }
        {{CSV Files}       {.csv}        }
        {{All Files}        *            }
    }
    set filename [tk_getOpenFile -filetypes $types]
    if {$filename != ""} {
        if [winfo exists .dialog] {
            destroy .dialog
            catch {unset ::import}
        }
        set dialog [Dialog .dialog \
                    -title "Import Options" \
                    -anchor e]
        set uf [$dialog getframe]
        set intext [Scrolled $uf.text text]
        $intext configure -wrap none -height 12 -relief raised
        $intext tag configure header -foreground #990000 -relief ridge
        $intext insert end [File:GetLines $filename 0 0] header
        $intext insert end [File:GetLines $filename 1 7]
        $intext insert end ".\n.\n[File:CountLines $filename] lines\n"
        set import(file) $filename
        set import(header) 1
        pack [checkbutton $uf.header -text "First Line contains column headers" -variable import(header)] -anchor w -pady 5
        set w [LabelComboBox $uf.lbl "Field Separator:" ]
        pack [lindex $w 0]  -pady 5 -anchor w
        set cb [lindex $w 2]
        set import(tablename) [file root [file tail $filename]]
        pack [LabelEntry $uf.tn -textvariable import(tablename) \
              -label "Tablename:        " ] -pady 5 -anchor w
        
        if { $append eq "yes" } {
        set import(tablename) $var(lastview)
        $uf.tn configure -editable false
        }
        $cb configure -text "comma" -values "comma semicolon tab space" -textvariable import(sepi) -textvariable import(sepi) -modifycmd {
            set headerline [File:GetLines $import(file) 0 0]
            set firstline  [File:GetLines $import(file) 1 1]
            set types 0
            if {$import(sepi) eq "space"} {
                set headerline [string trim $headerline]
                set firstline [string trim $firstline]
                regsub -all {\s+} $headerline " " headerline
                regsub -all {\s+} $firstline " " firstline
            }
          
            set cols [split $headerline $sep($import(sepi))] 
            foreach type [split $firstline $sep($import(sepi))] { lappend types $type }
            foreach child [winfo children $gui(import-cols)] {
                destroy $child
            }
            grid [label $gui(import-cols).imp -text "Import"] \
                      [label $gui(import-cols).cols -text "Column"]  \
                      [label $gui(import-cols).types -text "Type"] 
                      
            set x 1
            foreach col $cols {
                #Debug $col
                regsub "\n" $col "" col
                set import(column-$x) $col
                set import(type-$x) [Mk:GetStringType [lindex $types $x]]
                set import(include-$x) 1
                grid [checkbutton $gui(import-cols).imp$x -variable import(include-$x)] -row $x -column 0
                grid [entry $gui(import-cols).col$x -textvariable import(column-$x)] -row $x -column 1 -padx 5 -pady 5
                grid [ComboBox $gui(import-cols).type$x -textvariable import(type-$x) \
                      -editable false -values {" " S I L F D B}]  -row $x -column 2
                set import(max) $x
                incr x
            }
            .dialog itemconfigure 0 -state normal
        }
        #        pack [frame $uf.lf ] -fill x -pady 5
        set sw [ScrolledWindow $uf.cols -relief sunken -borderwidth 2]
        set sf [ScrollableFrame $sw.f]
        $sw setwidget $sf
        pack $sw -fill both -expand yes
        set gui(import-cols) [$sf getframe] ;#[Scrolled $uf.cols ScrollableFrame]

       set gui(import-cols) [Scrolled $uf.cols ScrollableFrame]
       $dialog add -text "Submit" -state disabled -command [list $dialog enddialog "submit"]
       $dialog add -text "Cancel" -command [list $dialog enddialog "Cancel"]
       set result [$dialog draw]
       set import(lines) [File:CountLines $filename]
       set var(progress) 0
       if {[string equal $result "submit"]} {
           Mk:Open $var(lastfile)
           Table:Import:File $filename $append
           Mk:Close
           File:Load $var(lastfile)
           destroy .dialog
           catch {unset ::import}
       } else {
           set var(statustext) "Table Import Operation Was Cancelled!!"
       }
   }
}
proc Table:Import:File {filename append} {
    global import sep var
    set x 0
    set table [file tail [file rootname $filename]]
    set headers [Table:Import:GetHeaders]
    #Debug [llength $headers]
    if {$append eq "yes"} {
        regsub -all ":S" $headers "" layout
        if {[mk::view layout mkdb.$import(tablename)] ne $layout} {
            # wrong column format
            tk_messageBox -title "Info!" -icon info -message "wrong columns $headers for import into $import(tablename) ..." -type ok
            destroy .dialog
            catch {unset ::import}
            return
        }
        set vw [mk::view layout mkdb.$import(tablename) $headers]
    } else {
        set vw [mk::view layout mkdb.$import(tablename) $headers]
    }
   
    if [catch {open $filename r} infh] {
        tk_messageBox -title "Info!" -icon info -message "Cannot open $filename: $infh" -type ok
        destroy .dialog
        catch {unset ::import}
        return
        
    }
    while {[gets $infh line] >= 0} {
        if { $x == 0 && $import(header) == 1} {
            incr x
            continue
        } else {
            if {$import(sepi) eq "space"} {
                regsub -all {\s+} $line " " line
               
            }
            set line [string trim $line]
            set allcols [split $line "$sep($import(sepi))"]
            set cols {}
            for {set j 1} {$j <= $import(max)} {incr j} {
                set k $j
                incr k -1
                if {$import(include-$j) == 1} {
                    lappend cols [lindex $allcols $k]
                }
            }
            if {[llength $cols] == [llength $headers]} {
                for {set i 0} {$i < [llength $cols]} {incr i 1} {
                    lappend params [lindex $headers $i]
                    if {[lindex $cols $i] ne "NA" && [lindex $cols $i] ne "NULL"} {
                        lappend params [lindex $cols $i]
                    } else {
                        lappend params "-1"
                    }
                }
                mk::row append $vw $params
                if {[expr $x % 100]  == 0} {
                    set var(progress) [expr $x * 100 / $import(lines)]
                    set var(statustext) "$x items processed ..."
                    #update 
                    update idletasks
                }
                if {[expr $x % 1000]  == 0} {
                    set var(statustext) "$x items processed ... committing data ..."
                    #update 
                    update idletasks
                    mk::file commit mkdb
                }
            }
        }
        incr x
    }
    close $infh
    set var(progress) 100
    set var(statustext) "$x items commiting ..."
    #update 
    update idletasks
    mk::file commit mkdb
    set var(statustext) "$x items processed!"
}
proc File:New {} {
    global mnu var
    set types {
          
        {{Metakit Files}       {.mk}        }
        {{All Files}        *.*            }
    }
    set filename [tk_getSaveFile -filetypes $types -initialdir $var(lastdir)]
    if {$filename != ""} {
        Mk:Open $filename
        Mk:Close
        set var(lastfile) $filename
        set var(lastdir) [file dirname $filename]
        ini_option_set LASTFILE $filename
        $mnu(file) entryconfigure 5 -state normal
        wm title . "$var(appname) $var(version) - [file tail $filename]"
        set var(statustext) "$filename was created successfully"
    }
}
proc File:Open { } {
  global var mnu
  set types {
          
        {{Metakit Files}       {.mk}        }
       
        {{All Files}        *.*            }
    }
    set filename [tk_getOpenFile -filetypes $types -initialdir $var(lastdir)]
    if {$filename != ""} {
        set var(lastfile) $filename
        set var(lastdir) [file dirname $filename]
        ini_option_set LASTFILE $filename
        File:Load $filename
        set var(statustext) "$filename was loaded!"            
            
    }
}
proc Tree:TextSelect {node} {
    global gui  var mnu
    #t
    $gui(tree) selection set $node
    if {[$gui(tree) parent $node] eq "root"} {
        set var(lastview) [$gui(tree) itemcget $node -text]
        #$mnu(file) entryconfigure 8 -label "Import data into view $var(lastview)" -state normal
        Mk:Open $var(lastfile)
        
        set var(searchcolumn) [lindex [mk::view layout mkdb.$var(lastview)] 0]
        catch {  
            foreach cb $gui(cb-columns) {
                $cb configure -values [mk::view layout mkdb.$var(lastview)] 
            }
        }
        Mk:Close
    } 
        
}
proc Tree:Load {parent view info} {
    global gui img
    if {[llength $info] > 1} {
        set subname [lindex $info 0]
        set sublayout [lindex $info 1]
        $gui(tree) insert end $parent $view -text "$subname" -image  $img(table)
        set x 0
        foreach item $sublayout {
            $gui(tree) insert end $view $view.$x -text "$item" -image  $img(field)
            incr x
        }
        #set info [mk::view info mkdb.$view.$subview]
    } else {
        $gui(tree) insert end $parent $view -text "$info" -image  $img(field)
    }
}
proc File:Load {filename} {

    global mnu gui var dir img
    set var(fileload) 0
    if {![file exists $filename]} { 
        tk_messageBox -title "Error!" -icon error  -message "$filename does not exists!" -type ok
        return
    }
    ini_unshift RECENTS $filename 9
    ini_mnu_update  $mnu(file-recent) RECENTS File:Load 9
    mk::file open mkdb $filename
    set var(lastfile) $filename
    $gui(views) delete 0 end
    $gui(tree) delete [$gui(tree) nodes root]
    set x 0
    $gui(lastview) configure -values {}

    foreach  view [mk::file views mkdb] {
        $gui(lastview) configure -values "[$gui(lastview) cget -values] $view"
        incr x
        $gui(tree) insert end root view$x -text $view -image $img(table)
        if {[string match "mk_*" $view]} {
            $gui(tree) itemconfigure view$x -fill red
        }
        set info [mk::view layout mkdb.$view] 
        set y 0
        foreach info $info {
            incr y
            Tree:Load view$x view$x.$y $info
        }
        $gui(views) insert end test
        $gui(views) cellconfigure end,0 -text $view
       
        $gui(views) cellconfigure end,1 -text [mk::view size mkdb.$view]
        $gui(views) cellconfigure end,2 -text [mk::view layout mkdb.$view]
        if {[string match "mk_*" $view]} {
            $gui(views) rowconfigure end -foreground red
        }
    }
    if { $x > 0 } {
        set var(lastview) [$gui(views) cellcget 0,0 -text]
        #$mnu(file) entryconfigure 8 -label "Import data into view $var(lastview)" -state normal
        foreach cb $gui(cb-columns) {
            $cb configure -values [mk::view layout mkdb.$var(lastview)]
        }
        set var(searchcolumn) [lindex [mk::view layout mkdb.$var(lastview)] 0]
    } else {
       tk_messageBox -title "Info!" -icon info -message "There are no tables inside this database" -type ok 
    }
    
    mk::file close mkdb
    $mnu(file) entryconfigure 5 -state normal
    if {$var(sqlite)} {
        $mnu(file) entryconfigure 10 -state normal
        $mnu(file) entryconfigure 11 -state normal
    }
    wm title . "$var(appname) $var(version) - [file tail $filename]"
    set var(fileload) 1
 
    
}
proc Table:GetCellText {w x y} {
    set tablelist::x $x
    set tablelist::y $y
    set index [$w nearestcell $tablelist::x $tablelist::y]
    return [$w cellcget $index -text]
    
}
proc Table:GetRow {x y } {
    global gui 
    set tablelist::x $x
    set tablelist::y $y
    set index [$gui(views) nearestcell $tablelist::x $tablelist::y]
   
    return $index
}
proc Record:Select {body} {
    global gui
    set parent [winfo parent $body]
    set selectedRow [$parent curselection]
    if {[llength $selectedRow] == 1} {
        set recID  [lindex [$parent get $selectedRow] 1]
        Record:Edit $recID $selectedRow
    }
}
proc Record:Edit {recID tableRow} {
    global var gui
 
    Mk:Open $var(lastfile)
    set view $var(view-$var(nb-raised))
    #incr recID -1
    #Debug "view: $view rec: $recID row: $tableRow"
    #mk::cursor create thisCursor $view $recID
    #mk::get mkdb.$view!
    if { [ catch {set record [mk::get mkdb.$view!$recID] } ] } {
        tk_messageBox -title "Info!" -icon info -message "The view $view does not exists in the current loaded database!" -type ok
        Mk:Close
        return
    }
    
    
    array set ::thisData $record
    #Debug $record

    set dialog [Dialog .dialog \
        -title "Edit Record $recID in view \"$view\"" \
        -anchor e]
    set uf [$dialog getframe]

    set count 0
    foreach {header data} $record {
        incr count
        set label [label $uf.l$count -text "${header}:" -anchor e]
        set type [Mk:GetType ${header}]
        #Debug "$header $type"
        if {$type eq "B"} {
            set import(tmp) "binary no edit"
            set entry [Entry $uf.e$count -textvariable import(tmp) -editable false -background grey -width 30]
        } else {
            set vals ""
            if {[Mk:HasView mk_column_values]} {
                set vals [mk::select mkdb.mk_column_values  -exact column $header -count 1]
                if {$vals ne ""} {
                    set vals [lindex [mk::get  mkdb.mk_column_values!$vals] 3]
                    #Debug $vals
                }
                
            }
           
            #            set idx [lsearch -exact [mk::view layout mkdb.column_values] $header]
            #            if { $idx >= 0} {
            #                #Debug $idx
            #            }
            if {$vals eq ""} {
                set entry [entry $uf.e$count -textvar ::thisData($header) -width 30]
            } else {
                if {$vals eq "filename"} {
                    
                    set entry [Entry $uf.e$count -textvariable ::thisData($header) -width 30 -command {
                               set filename [tk_getOpenFile -filetypes $var(types) -initialdir [ini_option_get LASTRECORD]]
                               if {$filename != ""} {
                                   ini_option_set LASTRECORD [file dirname $filename]
                                   $gui(filename_image) delete 0 end
                                   $gui(filename_image) insert end $filename
                               }   
                           }]
                      set gui(filename_image) $uf.e$count   
               } else {
                   set entry [ComboBox $uf.e$count -textvariable ::thisData($header) -width 30 -editable false -values $vals]
               }
            }
        }
        if {$type eq "F" && $vals eq ""} {
            wcb::callback $uf.e$count before insert WCB:checkFloat
        } elseif {$type eq "I" && $vals eq ""} {
            wcb::callback $uf.e$count before insert WCB:checkInteger
        } 
        grid $label $entry -padx 2 -pady 2 -sticky ew
    }

    #grid columnconfigure $uf 1 -weight 1

    $dialog add -text "Change" -command [list $dialog enddialog "change"]
    $dialog add -text "Insert" -command [list $dialog enddialog "insert"]
    $dialog add -text "Append" -command [list $dialog enddialog "append"]
    $dialog add -text "Delete" -command [list $dialog enddialog "delete"]
    $dialog add -text "Cancel" -command [list $dialog enddialog "cancel"]
    set result [$dialog draw]
    if {[string match "*.kit" $var(lastfile)]} {
        if {$result ne "cancel"} {
            tk_messageBox -title "Info!" -icon info -message "You are crazy ...\nFor obvious resons I disallow editing of starkit files!" -type ok
        }
        set result cancel
              
    }
    switch -exact -- $result {
        change {
            # --- put the data in the db
            eval mk::set mkdb.$view!$recID [array get ::thisData]
            # --- update the tablelist with the new data from the db
            set record [mk::get mkdb.$view!$recID]
            # --- get the record number (for col #1) from the current db cursor val
            set thisData $tableRow
            #lappend thisData [lindex [split mkdb.$view!$recID "!"] 1]
            lappend thisData $recID
            #incr thisData
            foreach {header data} $record {
                lappend thisData $data
            }
            $gui(data) rowconfigure $tableRow -text $thisData
            set var(statustext) "Record $recID was changed!"
        }
        insert {
            mk::row insert mkdb.$view!$recID 1 
            eval mk::set mkdb.$view!$recID [array get ::thisData]
            
            #updating the gui
            set thisData $tableRow
            lappend thisData $recID
            foreach {header data} [mk::get mkdb.$view!$recID] {
                lappend thisData $data
            }
            $gui(data) insert $tableRow "test"
            $gui(data) rowconfigure $tableRow -text $thisData
            for {set i [expr $tableRow + 1]} {$i < [$gui(data) size]} {incr i 1} {
                set cur [$gui(data) cellcget $i,1 -text]
                incr cur 
                $gui(data) cellconfigure $i,1 -text "$cur"
            }
            set var(statustext) "Record $recID was inserted!"
        }
        append {
            mk::row append mkdb.$view [array get ::thisData]
        }
        delete {
            set answer [tk_messageBox -title "Question!" -message "Really delete Entry $recID?" -type yesno -icon question]
            if { $answer } {
                eval mk::row delete mkdb.$view!$recID
                $gui(data) delete $tableRow
                for {set i $tableRow} {$i < [$gui(data) size]} {incr i 1} {
                    set cur [$gui(data) cellcget $i,1 -text]
                    incr cur -1
                    $gui(data) cellconfigure $i,1 -text "$cur"
                }
                
            } 
        }
    } 
    destroy $dialog
    catch {unset ::thisData}
    mk::file commit mkdb
    Mk:Close 
    
}
proc File:GetLines {filename start end} {
    set x -1
    set text ""
    if [catch {open $filename r} infh] {
        tk_messageBox -title "Info!" -icon info -message "Cannot open $filename: $infh" -type ok
     
    } else {
        while {[gets $infh line] >= 0} {
            incr x
            if {$x < $start} {continue}
            append text "$line\n"
           
            if {$x >= $end} { break }
           
            
            
        }
        close $infh
    } 
    return $text
}
proc Mk:GetType {column} {
    global var
    set type string
    set layout [mk::view layout mkdb.$var(view-$var(nb-raised))]
    if {[string match "*$column:*" "$layout"]} {
        regsub ".*$column:(.).*" $layout "\\1" type
    } else {
        set type string
    }
  
 
    #Debug "$column has $type"  
    return $type

}
proc Mk:GetStringType {string} {

    if {[string is integer $string]} {
        return "I"
    } elseif {[string is double $string]} {
        return "F"
    } else {
        return "S"
    }
}
proc NoteBook:AddPage {} {
    global var gui
    $gui(nb-data) insert end page$var(nb-total) -text page$var(nb-total) -raisecmd {NoteBook:Raise}
  
    set f [$gui(nb-data) getframe page$var(nb-total)]
   
    pack [label $f.lbl -textvariable var(stm-$var(nb-total))]
    set gui(data) [Scrolled $f tablelist]
    set gui(data-$var(nb-total)) $gui(data)
    set body [$gui(data) bodypath]
    bind $body <Double-Button-1> {Record:Select %W}

    incr var(nb-total)
}
proc NoteBook:Raise { } {
    global gui var
    set page [$gui(nb-data) raise]
    regsub page $page "" x
    set gui(data) $gui(data-$x)
    set var(nb-raised) $x

}
proc NoteBook:Popup {page} {
    global gui var
    #Debug $page
    if {[winfo exists .tmenu]} {destroy .tmenu}
    menu .tmenu -tearoff 0
    .tmenu add command -label "New Tab" -command "NoteBook:AddPage"
    set curIndex [$gui(nb-data) index $page]
    set endIndex [llength [$gui(nb-data) pages]]
    incr endIndex -1
    if { $curIndex > 0} {
        set newIndex $curIndex
        incr newIndex -1
        set var(tcmd)  "$gui(nb-data) move $page $newIndex"
        .tmenu add command -label "switch left" -command {
            eval $var(tcmd)
        }
    }
    if { $curIndex < $endIndex } {
        set newIndex $curIndex
        incr newIndex 1
        set var(t2cmd)  "$gui(nb-data) move $page $newIndex"
        .tmenu add command -label "switch right" -command {
            eval $var(t2cmd)
        }
    }
    set x [winfo pointerx .]
    set y [winfo pointery .]
    tk_popup .tmenu $x $y 
}
proc WCB:checkFloat {w idx str} {
    set newText [wcb::postInsertEntryText $w $idx $str]
    if {![regexp {^[-0-9e\.]*$} $newText]} {
        wcb::cancel
    }
}
proc WCB:checkInteger {w idx str} {
    set newText [wcb::postInsertEntryText $w $idx $str]
    if {![regexp {^[-0-9]*$} $newText]} {
        wcb::cancel
    }
}
proc Trace:Var {array index ops} {
    global mnu var gui
    if {$index eq "lastview"} {   
        $mnu(file) entryconfigure 8 -label "Import data into view $var($index)" -state normal
    } elseif {$index eq "gui,data,stretch"} {
        if {$var(gui,data,stretch)} {
            $gui(data) configure -stretch all
        } else {
            $gui(data) configure -stretch end
        }
    } elseif {$index eq "busy"} {
        if {$var(busy)} {
            GUI:Busy 1
        } else {
            GUI:Busy 0
        }
    }
}
proc Mk:GetViews {} {
    global var
    set values {}
    catch { 
        Mk:Open $var(lastfile)
        set values "[mk::view info mkdb]"
        regsub -all ":V" $values "" values
        Mk:Close
    }
    return $values
}
proc Oomk:GetColumns {view} {
    global var
    set db [mkstorage %AUTO% $var(lastfile)]
    set columns [$db layout $view]
    return $columns
    
}
proc Oomk:GetViews {} {
    global var
     set db [mkstorage %AUTO% $var(lastfile)]
    return [$db layout]
}
proc Oomk:ViewCopy {name newname} {
    global var
    catch {destroy .dlg}
    toplevel .dlg
    pack [labelframe .dlg.lf -title "Import Columns ..." -text " Import Columns" ] -side top -expand yes -fill both -ipadx 10 -ipady 10
    set db [mkstorage %AUTO% $var(lastfile)]
    [$db view $name] as view
    set x 0
    foreach prop [$view properties] {
        incr x
        set var(view,copy,$prop) 1
        pack [frame .dlg.lf.f$x] -side top -expand yes -fill x -anchor w
        pack [checkbutton .dlg.lf.f${x}.cb -variable var(view,copy,$prop) -text $prop] -side left
    }
    pack [frame .dlg.fr] -side top -expand yes -fill x -ipadx 10 -ipady 10
    pack [button .dlg.fr.copy -text " Copy " -command {
          set db [mkstorage %AUTO% $var(lastfile)]
          [$db view $var(view,rename,from)] as view
          Oomk:CreateView $db $var(view,rename,to) $view
          [$db view $var(view,rename,from)] as viewnew
          foreach prop [$view properties] {
              #puts "$prop $var(view,copy,$prop)"
              if {$var(view,copy,$prop)} {
                  append nprop "$prop "
              }
          }
          $db layout $var(view,rename,to) $nprop
          $db commit
          File:Load $var(lastfile)
      }
      ] -side left -fill x -anchor c -expand yes
   pack [button .dlg.fr.cancel -text " Cancel " -command { destroy .dlg}] -side left -fill x -anchor c -expand yes
  
}
proc Oomk:ViewRename {oldname newname} {
    global var
    set db [mkstorage %AUTO% $var(lastfile)]
    [$db view $oldname] as viewold
    Oomk:CreateView $db $newname $viewold
    $db layout $oldname ""
    #$oldname delete
    $db commit
    #db close
    set var(progress) 100
    set var(statustext) "Renaming done!"
}
proc Oomk:Join {modus} {
    global var gui
    set db [mkstorage %AUTO% $var(lastfile)]
    [$db view $var(join,v1)] as v1
    [$db view $var(join,v2)] as v2
    set stm "|$db view $var(join,v1)| join |$db view $var(join,v2)| $var(join,col)" ;
    foreach prop [$v1 properties] {
        if {$prop ne "$var(join,col)" && $prop ne "$var(join,colB)"} {
            [$v1 rename $prop $var(join,v1)_$prop] as v1
        }
    }
    foreach prop [$v2 properties] {
        if {$prop ne "$var(join,col)"} {
            [$v2 rename $prop $var(join,v2)_$prop] as v2
        }
    }
    #tk_messageBox -title "Info!" -icon info -message " common: $common" -type ok
    [$v1 join $v2 $var(join,col) $var(join,colB)] as vjoin
    if {$modus eq "table"} {
        $gui(nb-data) itemconfigure [$gui(nb-data) raise] -text "$var(join,v1) join $var(join,v2)"
        set var(stm-$var(nb-raised)) "\[$var(join,v1) join $var(join,v2) $var(join,col)\]"
    }
    if {$var(join,v3) ne "" && $var(join,col2) ne ""} {
        [$db view $var(join,v3)] as v3
        foreach prop [$v3 properties] {
            if {$prop ne "$var(join,col2)" && $prop ne "$var(join,col2B)"} {
                [$v3 rename $prop $var(join,v3)_$prop] as v3
            }
        }
        foreach prop [$vjoin properties] {
            if {[string match "*_$var(join,col2)" $prop]} {
                [$vjoin rename $prop  $var(join,col2)] as vjoin
            }
            if {[string match "*_$var(join,col2B)" $prop]} {
                [$vjoin rename $prop  $var(join,col2B)] as vjoin
            }
        }
       
        [$vjoin join $v3 $var(join,col2) $var(join,col2B)] as vjoin2
        if {$modus eq "table"} {
            $gui(nb-data) itemconfigure [$gui(nb-data) raise] -text "$var(join,v1) join $var(join,v2) join $var(join,v3)"
            set var(stm-$var(nb-raised)) "\[\[$var(join,v1) join $var(join,v2) $var(join,col)\] join $var(join,v3) $var(join,col2)\]"
        }
        set vjoin $vjoin2
    }
   
    Oomk:Execute $modus join $vjoin $db
}
proc Oomk:Execute {modus kind view db} {
    global gui var
    set props n
    if {$kind eq "select"} {
        lappend props rec
    }
    set props [concat $props [$view properties]]
    if {$modus eq "table"} {
        Tablelist:Colconf $gui(data) 20 $props
        
        $gui(data) delete 0 end
    } else {
        set types {
            {{Tab Files}       {.tab}        }
            {{All Files}        *             }
        }
        set filename [tk_getSaveFile -filetypes $types]
        if {$filename != ""} {
            set out [open $filename w 0600]
            set p [$view properties]
            puts $out [join $p \t]
         
            
        } else {
            return
        }
    }
    set z 0
    set size [$view size]
    set max $size
    if {$modus eq "table"} {
        set max $var(count)
    }
    $view loop c {
        incr z
        GUI:Status $z $max
        if {$modus eq "table"} {
            if {$z  == $var(count)} {
                $view lbreak
            }
            if {$z < $var(start) && $modus eq "table"} {
                $view lcontinue
            }
            #puts [array get c]
            $gui(data) insert end $z
            
            foreach  prop $props {
                if {$prop eq "rec"} {
                    $gui(data) cellconfigure end,1 -text $c(#) 
                } else {
                    $gui(data) cellconfigure end,[lsearch -exact $props $prop] -text $c($prop) 
                
                }
            }
            $gui(data) cellconfigure end,0 -text $z
        } else {
            set p {}
            foreach  prop $props {
                lappend p $c($prop)
            }
            puts $out [join [lrange $p 1 end] \t]
        }
        
    }
    set var(progress) 100
    set var(statustext) "$z items from $size processed !"
    if {$modus eq "export"} {
        close $out
    }
    if {$var(saveviewname) ne ""} {
        Oomk:CreateView $db $var(saveviewname) $view
        set var(saveviewname) ""
        File:Load $var(lastfile)
    }
}
proc Oomk:CreateView {db name view} {
    global var gui
    $db layout $name [$view properties]
    [$db view $name] as viewnew
    set z 0
    set size [$view size]
    $view loop c {
        set cmd [list $viewnew append]
        foreach {x y} [array get c] {
            if {$x ne "#"} {
                lappend cmd $x $y
            }
        }
        #puts [array get c]
        eval $cmd
        incr z
        GUI:Status $z $size
    }
    $db commit
    set var(progress) 100
    set var(statustext) "$z / $size items processed !"
    
}
proc GUI:Status {z size} {
    global gui var
  
    if {$z % 100 == 0} {
        set var(progress) [expr $z * 100 / $size]
        set var(statustext) "$z / $size items processed ..."
        update 
        #update idletasks
    }
}
proc Oomk:NoOps {view op args} {
    global var gui
    set db [mkstorage %AUTO% $var(lastfile)]
    [$db view $view] as v
    set v2 ""
    if {[llength $args] == 1} {
        # binary view ops
        [$db view "[lindex $args 0]"] as v2
        [$v $op $v2] as vresult
    } else {
        # unary view ops
        [$v $op] as vresult
    }
    Oomk:Execute table noops $vresult $db
    
}
proc GUI:Busy {i} {
    global gui
    set ws [list $gui(views) $gui(data) $gui(tree)]
    foreach w [winfo children $gui(nb)] {
        lappend ws $w
    }
    foreach w $ws {
        $w configure -cursor [lindex {arrow watch} $i]
                              
    }
    #update 
    update idletasks
}
proc GUI:Oomk {} {
    global gui var
    pack [labelframe $gui(foomk).lf -text "Unary View Ops"] -side top -expand yes -fill both -ipadx 5 -ipady 5
    button $gui(foomk).lf.help -text ? -command {help 21}
    mComboBox $gui(foomk).lf.cb1 -labeltext View: -labelwidth 10 \
              -postcommand { $gui(foomk).lf.cb1 configure -values [ldelete [Mk:GetViews] mk_column_values mk_joined_views]} \
              -textvariable var(oomk,unaryview) 
    mComboBox $gui(foomk).lf.cb2 -labeltext Operator: -labelwidth 10 \
              -postcommand { $gui(foomk).lf.cb2 configure -values {clone copy readonly unique} } \
              -textvariable var(oomk,unaryops) 
    button $gui(foomk).lf.btn -text "Execute" -command {Oomk:NoOps $var(oomk,unaryview) $var(oomk,unaryops)}
    Pack:Childs $gui(foomk).lf -side top -padx 5 -pady 3
    pack [labelframe $gui(foomk).lf2 -text "Binary View Ops"] -side top -expand yes -fill both -ipadx 5 -ipady 5
    button $gui(foomk).lf2.help -text ? -command {help 22}
    mComboBox $gui(foomk).lf2.cb1  -labeltext "View 1:" -labelwidth 10 \
              -postcommand { $gui(foomk).lf2.cb1 configure -values [ldelete [Mk:GetViews] mk_column_values mk_joined_views]} \
              -textvariable var(oomk,binaryview1) 
    mComboBox $gui(foomk).lf2.cb2 -labeltext Operator: -labelwidth 10 \
              -postcommand { $gui(foomk).lf2.cb2 configure -values {concat different intersect map minus pair product union} } \
              -textvariable var(oomk,binaryops) 
    mComboBox $gui(foomk).lf2.cb3 -labeltext "View 2:"  -labelwidth 10 \
              -postcommand { $gui(foomk).lf2.cb3 configure -values [ldelete [Mk:GetViews] $var(oomk,binaryview1) mk_column_values mk_joined_views]} \
              -textvariable var(oomk,binaryview2) 
  
    button $gui(foomk).lf2.btn -text "Execute" -command {
        if {$var(oomk,binaryview1) ne "" && \
                      $var(oomk,binaryops) ne "" && \
                      $var(oomk,binaryview2) ne ""} {
            Oomk:NoOps $var(oomk,binaryview1) $var(oomk,binaryops) $var(oomk,binaryview2)
        }
    }
    
    
    Pack:Childs $gui(foomk).lf2 -side top -padx 5 -pady 3
  

}
proc GUI:Join {} {
    global gui var
    pack [labelframe $gui(fjoin).lf -text "Join Views"] -side top -expand yes -fill both -ipadx 5 -ipady 5
    frame $gui(fjoin).lf.f
    pack [button $gui(fjoin).lf.f.help -text ? -command {help 24}] -side left -fill x -padx 10 -pady 5 -expand yes
    pack [button $gui(fjoin).lf.f.btntj -text " Table Join " -command {if {$var(join,col) ne ""} { Oomk:Join table}}] -side left -fill x -padx 10 -pady 5 -expand yes
    pack [button $gui(fjoin).lf.f.btnej -text " Export Join " -command {if {$var(join,col) ne ""} { Oomk:Join export}}] -side left -fill x -padx 10 -pady 5 -expand yes
  
    mComboBox $gui(fjoin).lf.v1 -labelside top -labeltext view1 \
              -postcommand {$gui(fjoin).lf.v1 configure -values [ldelete [Mk:GetViews] $var(join,v2) mk_column_values mk_joined_views]} \
              -textvariable var(join,v1) 
    mComboBox $gui(fjoin).lf.v2 -labelside top -labeltext view2 \
              -postcommand { $gui(fjoin).lf.v2 configure -values [ldelete [Mk:GetViews] $var(join,v1) mk_column_values mk_joined_views]} \
              -textvariable var(join,v2)    
    frame $gui(fjoin).lf.f0
    mComboBox $gui(fjoin).lf.f0.col -labelside top -labeltext column1-2A \
              -textvariable var(join,col) \
              -postcommand { 
        if {$var(join,v1) ne "" && $var(join,v2) ne ""} {
            set v1 [Oomk:GetColumns $var(join,v1)]
            set v2 [Oomk:GetColumns $var(join,v2)]
            $gui(fjoin).lf.f0.col configure -values [lintersect $v1 $v2]
        }
    }
     mComboBox $gui(fjoin).lf.f0.colB -labelside top -labeltext column1-2B \
              -textvariable var(join,colB) \
              -postcommand { 
         if {$var(join,v1) ne "" && $var(join,v2) ne "" && $var(join,col) ne ""} {
            set v1 [Oomk:GetColumns $var(join,v1)]
            set v2 [Oomk:GetColumns $var(join,v2)]
            $gui(fjoin).lf.f0.colB configure -values [ldelete [lintersect $v1 $v2] $var(join,col)]
        }
    }
    pack $gui(fjoin).lf.f0.col $gui(fjoin).lf.f0.colB -side left -fill x -expand yes
    mComboBox $gui(fjoin).lf.v3 -labelside top -labeltext view3 \
              -postcommand { $gui(fjoin).lf.v3 configure -values [ldelete [Mk:GetViews] $var(join,v1) $var(join,v2) mk_column_values mk_joined_views]} \
              -textvariable var(join,v3)
    frame $gui(fjoin).lf.f1 
    mComboBox $gui(fjoin).lf.f1.col2 -labelside top -labeltext "column(1-2)-3-A" \
              -textvariable var(join,col2) \
              -postcommand { 
        if {$var(join,v1) ne "" && $var(join,v2) ne "" && $var(join,v3) ne ""} {
            set v1 [Oomk:GetColumns $var(join,v1)]
            set v2 [Oomk:GetColumns $var(join,v2)]
            set v3 [Oomk:GetColumns $var(join,v3)]
            set v12 [concat $v1 $v2]
            $gui(fjoin).lf.f1.col2 configure -values [lintersect $v12 $v3]
        }
    }
    mComboBox $gui(fjoin).lf.f1.col2B -labelside top -labeltext "column(1-2)-3-B" \
              -textvariable var(join,col2B) \
              -postcommand { 
        if {$var(join,v1) ne "" && $var(join,v2) ne "" && $var(join,v3) ne ""} {
            set v1 [Oomk:GetColumns $var(join,v1)]
            set v2 [Oomk:GetColumns $var(join,v2)]
            set v3 [Oomk:GetColumns $var(join,v3)]
            set v12 [concat $v1 $v2]
            $gui(fjoin).lf.f1.col2B configure -values [ldelete [lintersect $v12 $v3] $var(join,col2)]
        }
    }
    pack $gui(fjoin).lf.f1.col2 $gui(fjoin).lf.f1.col2B -side left -fill x -expand yes
    Pack:Childs $gui(fjoin).lf -padx 5 -pady 3 -fill x
 
    #mLabEntry $gui(fjoin).lf.viewname -textvariable var(join,name) -helptext "Enter a name to save this as a virtual view!"
   
    #    foreach child [winfo children $gui(fjoin).lf] {
    #        pack $child -padx 5 -pady 5
    #    }
}
proc Pack:Childs {parent args} {
    foreach child [winfo children $parent] {
        eval pack $child $args
    }
}
proc SQLite:Export {} {
    global var
    set out [open file.ext w 0600]
  
    set db [mkstorage %AUTO% $var(lastfile)]
    set types {
        {{SQLite Files}       {.sqlite}        }
        {{All Files}        *             }
    }
    set filename [tk_getSaveFile -filetypes $types -title "Enter SQLite filename"]
    if {$filename != ""} {
        sqlite sql $filename
        sql eval "BEGIN TRANSACTION"
        foreach tab [Oomk:GetViews]  {
            lappend tables [lindex $tab 0]
        }
        foreach table $tables {
            if {[string match {mk_*} $table]} {
                 continue
             }
            set colls [Oomk:GetColumns $table]
            foreach col $colls {
                set coll [split $col :] 
                if {[llength $coll] == 1} {
                    lappend cols($table) "[lindex $coll 0] CHAR(250)"
                } elseif {[lindex $coll 1] eq "I"} {
                    lappend cols($table) "[lindex $coll 0] INTEGER"
                } elseif {[lindex $coll 1] eq "F"} {
                    lappend cols($table) "[lindex $coll 0] FLOAT"
                } else {
                    lappend cols($table) "[lindex $coll 0] CHAR(250)"
                }
            }
            sql eval "CREATE TABLE $table ([join $cols($table) ,])"
            [$db view $table] as nview
            set z 0
            set size [$nview size]
            set var(statustext) "Exporting $table ..."
            set var(progress) 0
            $nview loop c {
                incr z
                set col2 {}
                set values {}
                puts "exporting  [array get c]"
                foreach {name value} [array get c] {
                    if {$name eq "#"} {
                        continue
                    } 
                    lappend col2 $name
                    regsub -all "'" $value "''" value
                    lappend values "'$value'"
                }
                puts "sql eval \"INSERT INTO $table ([join $col2 ,]) VALUES ([join $values ,])\""
                sql eval "INSERT INTO $table ([join $col2 ,]) VALUES ([join $values ,])"
                if {$z % 100 == 0} {
                    set var(progress) [expr $z * 100 / $size]
                    set var(statustext) "Exporting $table $z / $size ..."
                    #update 
                    update idletasks
                }

            }
            
        }
        set var(progress) 100
        set var(statustext) "committing data ..."
        update idletasks
        sql eval "COMMIT"
        sql close
        close $out
        set var(statustext) "committing data done!"
    }
  
}
proc SQLite:Import {} {
    global var
    set types {
        {{SQLite Files}       {.sqlite}        }
        {{All Files}        *             }
    }
    set filename [tk_getOpenFile -filetypes $types]
    if {$filename != ""} {
        tk_messageBox -title "Info!" -icon info -message "$filename can't be processed because importing sqlite databases is still not implemented till now!" -type ok
        
    }
    
    
}
proc License:Check {} {
    global dir var
    set licensefile [file join $dir .. .. doc License.txt]
   
    if {[file exists $licensefile]} {
        if { [ini_option_get LICENSE ] ne "yes" } {
            toplevel .dialog 
            wm title .dialog "License Agreement"
            wm protocol .dialog WM_DELETE_WINDOW Exit
            set licensew [Scrolled .dialog.txt text]
            Text:LoadFile $licensew $licensefile
            pack [frame .dialog.fr] -side top -expand no 
            pack [button .dialog.fr.yes -text "I Agree" -width 20 -command {
                  ini_option_set LICENSE yes
                  destroy .dialog
                  set var(license) sone
              }] -side left -padx 10 -pady 5
            pack [button .dialog.fr.no -text "cancel" -width 20 -command {
                  destroy .dialog
                  ini_option_set LICENSE no
                  exit 0
              }] -side left  -padx 10 -pady 5
            wm withdraw .
            vwait var(license)
            wm deiconify .
        }
            
    }
}
proc Exit {} {
    ini_write ;  
    wm withdraw . ; 
    destroy . ; 
    exit 0
}
main
