#!/bin/sh
# -*- tcl -*- \
exec wish -file $0 ${1+"$@"}
##############################################################################
#
#  			Copyright 2004 $COMPANY$.
#			      All Rights Reserved
#
#
#  System        : THUMBNAIL_TCL
#  Module        : 
#  Object Name   : $RCSfile$
#  Revision      : $Revision$
#  Date          : $Date$
#  Author        : $Author$
#  Created By    : $AUTHOR$
#  Created       : $DATE$
#  Last Modified : <041029.1347>
#
#  Description	
#
#  Notes
#
#  History
#	
#  $Log$
#
##############################################################################
#
#  Copyright (c) 2004 $COMPANY$
# 
#  All Rights Reserved.
# 
#  This  document  may  not, in  whole  or in  part, be  copied,  photocopied,
#  reproduced,  translated,  or  reduced to any  electronic  medium or machine
#  readable form without prior written consent from MPIMG Berlin, Germany.
#
##############################################################################
package provide app-thumbnail 1.0
lappend auto_path d:/tcl-lib
package require snit 0.93
package require BWidget
snit::widget thumbnail {
    #hulltype toplevel|frame
    # options
    option -op1 ""
    option -extension gif
    # variables
    variable frame
    variable images
    variable canvas
    variable combo
    variable masterdir
    variable selecteddir
    variable imagesize 50%
    # typevariables
    typevariable tv1
    # delegates

    constructor {args} {
       
        pack [panedwindow $win.pan -orient horizontal] -side top -expand yes -fill both -pady 2 -padx 2
       
        pack [frame $win.pan.frame] -side left -expand yes -fill both
        pack [ComboBox $win.pan.frame.cb -textvariable [varname selecteddir]] -side top -fill x -expand no
        set combo $win.pan.frame.cb
        set sw [ScrolledWindow $win.pan.frame.sw -relief sunken -borderwidth 2]
        set sf [ScrollableFrame $sw.f]
        $sw setwidget $sf
        pack $sw -fill both -expand yes -side left
        pack [frame $win.pan.frame2] -side left -expand yes -fill both
        pack [ComboBox $win.pan.frame2.cb -values [list 100% 50% 33% 25% 12%] \
              -editable false -textvariable [varname imagesize]]
        pack [SnitScrolledImage $win.pan.frame2.c 400 300 {0 0 400 300}] -side left -fill both -expand yes
        set canvas $win.pan.frame2.c
        set frame [$sf getframe]
        $win.pan add $win.pan.frame2 $win.pan.frame 
        $self configurelist $args
        
    }   
    typeconstructor {
        
    }
    # public methods (are lowercase)
    # DESCRIPTION
    #     descr
    # ARGUMENTS
    #    arg1, arg2
    # RESULT
    #    what is returned
    # ***
    method loadMasterDir {dir} {
        set masterdir $dir
        set dirs [list]
        foreach d [glob -nocomplain $dir/*] {
            lappend dirs [file tail $d]
        }
        $combo configure -values $dirs -modifycmd [list $self loadDir]
    }
    method loadDir {} {
        set x 0
        set dir [file join $masterdir $selecteddir]
        foreach child [winfo children $frame] {
            destroy $child
        }
        foreach file [glob -nocomplain $dir/*.$options(-extension)] {
            incr x
            set lab [label $frame.l$x -text [file tail $file] -anchor w]
            set can [canvas $frame.c$x]
            set img [image create photo Photo -file $file]
            image create photo temp$x
            temp$x copy $img -shrink -subsample 10 10
            $can configure -width [image width temp$x]
            $can configure -height [image height temp$x]
            $can create image 0 0 -anchor nw -image temp$x
            pack $lab -side top -fill x -expand no
            pack $can -side top -fill both -expand yes
            set images($x) temp$x
            bind $can <Double-1> [list $self ShowImage $file]
            
           
        }
    }
    method ShowImage {file} {
        set image [image create photo Photo -file $file]
        image create photo temp
        switch -exact -- $imagesize {
            100% {
                set s 1 
            }
            50% {
                set s 2 
            }
            33% {
                set s 3  
            }
            25% {
                set s 4
            }
            12% {
                set s 8
            }
        }
        
        temp copy $image -shrink -subsample $s $s
        $canvas configure -width [image width temp]
        $canvas configure -height [image height temp]
        $canvas configure -scrollregion [list 0 0 [image width temp] [image height temp]]
        $canvas create image 0 0 -anchor nw -image temp
    }
    # private methods (are uppercase)
    method M1 {args} {

    }
}

# testing
if {[lindex $argv 0] eq "test"} {
    lappend auto_path [file dirname [info script]]
    
    package require Img 1.3
    package require imgtools
    puts testing
    thumbnail .win -extension jpg
    pack .win -expand yes -fill both
    #.win loadDir E:/links/project/amphioxus/ZF_DUPLICATED_GENES_INSITU_IMAGES/ZF_INSITU_IMAGES_PROCESSED/Zebrafish_Reference_photos/20somite-Prim5 jpg
    .win loadMasterDir E:/links/project/amphioxus/ZF_DUPLICATED_GENES_INSITU_IMAGES/ZF_INSITU_IMAGES_PROCESSED/Zebrafish_Reference_photos
  
}


